stages:
  - build
  - linter
  - sonar

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/main-0.0.1-SNAPSHOT.jar


linter:
  stage: linter
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs
  dependencies:
    - build


variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  stage: sonar
  image: maven:3.6.3-jdk-11
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=e.osokin_lab2-linter-and-sonar-as-a-part-of-qg-s22
  only:
    - merge_requests
    - master
    - develop
  allow_failure: true
